#include "shared.h"
short w=0,xmax=0;
short h=0,ymax=0;
short lj(short num)
{
	if(w+num<    0) return (xmax+num);
	if(w+num>=xmax) return w+num-xmax;
	                return w+num     ;
}
short li(short num)
{
	if(h+num<    0) return (ymax+num);
	if(h+num>=ymax) return h+num-ymax;
	                return h+num     ;
}
short cd(short a, short b)
{
	if(a-b>=0) return a-b; else return b-a;
}
short tmp_rs, tmp_gs, tmp_bs;
short px,py,nx,ny,spx,spy,snx,sny;
extern rgb alpha;
extern int shiftlong;
extern int shiftshort;
int len = 0;
#define prefilter
struct point
{
	int x;
	int y;
}start_pt,end_pt,cur_pt;
bool isE(rgb dot1, rgb dot2)
{
	return (dot1.r==dot2.r&&
			dot1.g==dot2.g&&
			dot1.b==dot2.b);
}
bool isA(rgb dot)
{
	return (dot.r==alpha.r&&
			dot.g==alpha.g&&
			dot.b==alpha.b);
}
void FlipH(rgb **image,short x,short y)
{
	rgb tmp;
	for(int i = 0; i < y; i++)
	{
		for(int j = 0; j < x/2; j++)
		{
			tmp.r = image[i][j].r;
			tmp.g = image[i][j].g;
			tmp.b = image[i][j].b;
			image[i][j].r = image[i][(x-1)-j].r;
			image[i][j].g = image[i][(x-1)-j].g;
			image[i][j].b = image[i][(x-1)-j].b;
			image[i][(x-1)-j].r = tmp.r;
			image[i][(x-1)-j].g = tmp.g;
			image[i][(x-1)-j].b = tmp.b;
		}
	}
}
void Grad(rgb **image,rgb **buf,short x,short y)
{
	for(int i = 0; i < y; i++)
	{
		int xstart=0;
		int xpos=0;
		int xlenght=1;
		bool xstartisset = false;
		do
		{
			if(isA(image[i][xpos]))
			{
				xpos=lj(++xpos);
				continue;
			}
			if(isE(image[i][xpos],image[i][lj(xpos+1)])&&!xstartisset)
			{
				xpos=lj(++xpos);
				continue;
			}
			if(!xstartisset)
			{
				xpos=lj(++xpos);
				xstart=xpos;
				xstartisset=true;
			}
			while(isE(image[i][xpos],image[i][lj(xpos+xlenght)]))
			{
				xlenght++;
			}
			//
			//if(xlenght > 1)
			//cout << xlenght << "\n";
			//continue here;
			if(xlenght/2>0&&!isA(image[i][lj(xpos-1)]))
			{
				for(int c = 0; c <= (xlenght/2); c++)
				{
					if(!isA(buf[i][lj(xpos+c)]))
					{
						buf[i][lj(xpos+c)].r = (image[i][lj(xpos-1)].r+image[i][lj(xpos)].r)/2*(1-(float)c/(xlenght/2))+image[i][lj(xpos+c)].r*(float)c/(xlenght/2);
						buf[i][lj(xpos+c)].g = (image[i][lj(xpos-1)].g+image[i][lj(xpos)].g)/2*(1-(float)c/(xlenght/2))+image[i][lj(xpos+c)].g*(float)c/(xlenght/2);
						buf[i][lj(xpos+c)].b = (image[i][lj(xpos-1)].b+image[i][lj(xpos)].b)/2*(1-(float)c/(xlenght/2))+image[i][lj(xpos+c)].b*(float)c/(xlenght/2);
					}
				}
			}
			xpos=lj(xpos+xlenght);
			xlenght=1;
			//system("pause");
			//
			//cout << xstart <<"!=" << xpos << "\n";
		}
		while(xstart!=xpos);
		//system("pause");
	}
}
void Recalculate(rgb **image,short x, short y)
{
	xmax = x; ymax = y;
	rgb ** tmp1; tmp1 = new rgb*[y];for(int i=0; i< y; i++)tmp1[i] = new rgb[x];
	rgb ** tmp2; tmp2 = new rgb*[y];for(int i=0; i< y; i++)tmp2[i] = new rgb[x];
	rgb ** tmp3; tmp3 = new rgb*[y];for(int i=0; i< y; i++)tmp3[i] = new rgb[x];
	rgb ** tmp4; tmp4 = new rgb*[y];for(int i=0; i< y; i++)tmp4[i] = new rgb[x];
	for(int i = 0; i < y; i++)
	{
		for(int j = 0; j < x; j++)
		{
			tmp1[i][j].r = image[i][j].r;
			tmp1[i][j].g = image[i][j].g;
			tmp1[i][j].b = image[i][j].b;
			tmp1[i][j].a = image[i][j].a;
			tmp1[i][j].l = 1;//image[i][j].l;

			tmp2[i][j].r = image[i][j].r;
			tmp2[i][j].g = image[i][j].g;
			tmp2[i][j].b = image[i][j].b;
			tmp2[i][j].a = image[i][j].a;
			tmp2[i][j].l = 1;//image[i][j].l;

			tmp3[i][j].r = image[i][j].r;
			tmp3[i][j].g = image[i][j].g;
			tmp3[i][j].b = image[i][j].b;
			tmp3[i][j].a = image[i][j].a;
			tmp3[i][j].l = 1;//image[i][j].l;

			tmp4[i][j].r = image[i][j].r;
			tmp4[i][j].g = image[i][j].g;
			tmp4[i][j].b = image[i][j].b;
			tmp4[i][j].a = image[i][j].a;
			tmp4[i][j].l = 1;//image[i][j].l;
		}
	}
	//
	//horizontal forward
	Grad(image,tmp1,x,y);
	FlipH(tmp1,x,y);
	FlipH(image,x,y);
	//rgb tmp;
	//for(int i = 0; i < y; i++)
	//{
	//	for(int j = 0; j < x/2; j++)
	//	{
	//		tmp.r = image[i][j].r;
	//		tmp.g = image[i][j].g;
	//		tmp.b = image[i][j].b;
	//		image[i][j].r = image[i][(x-1)-j].r;
	//		image[i][j].g = image[i][(x-1)-j].g;
	//		image[i][j].b = image[i][(x-1)-j].b;
	//		image[i][(x-1)-j].r = tmp.r;
	//		image[i][(x-1)-j].g = tmp.g;
	//		image[i][(x-1)-j].b = tmp.b;
	//	}
	//}
	Grad(image,tmp1,x,y);
	//Flip(image,x,y);
	FlipH(tmp1,x,y);
	FlipH(image,x,y);
	if(false)
	for(int i = 0; i < y; i++)
	{
		int xstart=0;
		int xpos=0;
		int xlenght=1;
		bool xstartisset = false;
		do
		{
			if(isA(image[i][xpos]))
			{
				xpos=lj(++xpos);
				continue;
			}
			if(isE(image[i][xpos],image[i][lj(xpos+1)])&&!xstartisset)
			{
				xpos=lj(++xpos);
				continue;
			}
			if(!xstartisset)
			{
				xpos=lj(++xpos);
				xstart=xpos;
				xstartisset=true;
			}
			while(isE(image[i][xpos],image[i][lj(xpos+xlenght)]))
			{
				xlenght++;
			}
			//
			//if(xlenght > 1)
			//cout << xlenght << "\n";
			//continue here;
			if(xlenght/2>0)
			{
				for(int c = 0; c <= (xlenght/2); c++)
				{
					tmp1[i][lj(xpos+c)].r = image[i][lj(xpos-1)].r*(1-(float)c/(xlenght/2))+image[i][lj(xpos+c)].r*(float)c/(xlenght/2);
					tmp1[i][lj(xpos+c)].g = image[i][lj(xpos-1)].g*(1-(float)c/(xlenght/2))+image[i][lj(xpos+c)].g*(float)c/(xlenght/2);
					tmp1[i][lj(xpos+c)].b = image[i][lj(xpos-1)].b*(1-(float)c/(xlenght/2))+image[i][lj(xpos+c)].b*(float)c/(xlenght/2);
				}
			}
			xpos=lj(xpos+xlenght);
			xlenght=1;
			//system("pause");
			//
			//cout << xstart <<"!=" << xpos << "\n";
		}
		while(xstart!=xpos);
		//system("pause");
	}
	//horizontal backward
	if(false)
	for(int i = y-1; i >= 0; i--)
	{
		int xstart=y-1;
		int xpos=y-1;
		int xlenght=1;
		bool xstartisset = false;
		do
		{
			if(isA(image[i][xpos]))
			{
				xpos=lj(--xpos);
				continue;
			}
			if(isE(image[i][xpos],image[i][lj(xpos-1)])&&!xstartisset)
			{
				xpos=lj(--xpos);
				continue;
			}
			if(!xstartisset)
			{
				xpos=lj(--xpos);
				xstart=xpos;
				xstartisset=true;
			}
			while(isE(image[i][xpos],image[i][lj(xpos-xlenght)]))
			{
				xlenght++;
			}
			//
			//if(xlenght > 1)
			//cout << xlenght << "\n";
			//continue here;
			if(xlenght/2>0)
			{
				for(int c = (xlenght/2); c > 0; c--)
				{
					tmp1[i][lj(xpos-c)].r = image[i][lj(xpos+1)].r*(1-(float)c/(xlenght/2))+image[i][lj(xpos-c)].r*(float)c/(xlenght/2);
					tmp1[i][lj(xpos-c)].g = image[i][lj(xpos+1)].g*(1-(float)c/(xlenght/2))+image[i][lj(xpos-c)].g*(float)c/(xlenght/2);
					tmp1[i][lj(xpos-c)].b = image[i][lj(xpos+1)].b*(1-(float)c/(xlenght/2))+image[i][lj(xpos-c)].b*(float)c/(xlenght/2);
				}
			}
			xpos=lj(xpos-xlenght);
			xlenght=1;
			//system("pause");
			//
			//cout << xstart <<"!=" << xpos << "\n";
		}
		while(xstart!=xpos);
		//system("pause");
	}
		cout << "good\n";
	//for(int i = 0; i < y; i++)
	//{
	//	int lenght=1;
	//	start_pt.x=0;
	//	start_pt.y=i;
	//	cur_pt.x=start_pt.x;
	//	cur_pt.y=start_pt.y;
	//	do
	//	{
	//		w = cur_pt.x;
	//		h = cur_pt.y;
	//		end_pt.x = lj(lenght);
	//		end_pt.y = start_pt.y;
	//		if(image[cur_pt.y][cur_pt.x].r==alpha.r&&
	//		   image[cur_pt.y][cur_pt.x].g==alpha.g&&
	//		   image[cur_pt.y][cur_pt.x].b==alpha.b)
	//		{
	//			cur_pt.x++;
	//			continue;
	//		}
	//		if(image[cur_pt.y][cur_pt.x].r==image[end_pt.y][end_pt.x].r&&
	//		   image[cur_pt.y][cur_pt.x].g==image[end_pt.y][end_pt.x].g&&
	//		   image[cur_pt.y][cur_pt.x].b==image[end_pt.y][end_pt.x].b)
	//		{
	//			lenght++;
	//		}
	//		else
	//		{
	//			if(lenght/2)
	//			{
	//				lenght/=2;
	//				//fail
	//			}
	//			lenght=1;
	//			cur_pt.x=end_pt.x;
	//			cur_pt.y=end_pt.y;
	//		}
	//	}
	//	while(start_pt.x!=end_pt.x&&start_pt.y!=end_pt.y);
	//}
	//for(int i = 0; i < y; i++)
	//{
	//	for(int j = 0; j < x; j++)
	//	{
	//		w = j; h = i;
	//		//horizontal
	//		px = lj(-1);
	//		py = li( 0);
	//		nx = lj(+tmp1[i][j].l);
	//		ny = li( 0);
	//		if(tmp1[i][j].r==alpha.r&&tmp1[i][j].g==alpha.g&&tmp1[i][j].b==alpha.b)continue;
	//		if(tmp1[i][j].r==tmp1[i][nx].r&&tmp1[i][j].g==tmp1[i][nx].g&&tmp1[i][j].b==tmp1[i][nx].b&&tmp1[i][j].l<=x)
	//		{
	//			tmp1[i][j].l++;
	//			j--;
	//			continue;
	//		}
	//		//else
	//		if(tmp1[i][j].l/2)
	//		{
	//			for(int t = j; t <= tmp1[i][j].l/2; t++)
	//			{
	//				tmp1[i][t]//save
	//			}
	//		}
	//	}
	//}
	//
	for(int i = 0; i < y; i++)
	{
		for(int j = 0; j < x; j++)
		{
			image[i][j].r = tmp1[i][j].r;
			image[i][j].g = tmp1[i][j].g;
			image[i][j].b = tmp1[i][j].b;
			//image[i][j].r = (tmp1[i][j].r+tmp2[i][j].r+tmp3[i][j].r+tmp4[i][j].r)/4;
			//image[i][j].g = (tmp1[i][j].g+tmp2[i][j].g+tmp3[i][j].g+tmp4[i][j].g)/4;
			//image[i][j].b = (tmp1[i][j].b+tmp2[i][j].b+tmp3[i][j].b+tmp4[i][j].b)/4;
		}
	}
	for(int i=0; i< y; i++)delete[] tmp1[i];delete[] tmp1;
	for(int i=0; i< y; i++)delete[] tmp2[i];delete[] tmp2;
	for(int i=0; i< y; i++)delete[] tmp3[i];delete[] tmp3;
	for(int i=0; i< y; i++)delete[] tmp4[i];delete[] tmp4;
}
void Recalculate2(rgb **image,short x, short y)
{
	xmax = x; ymax = y;
#ifdef prefilter
	rgb ** tmp0; tmp0 = new rgb*[y];for(int i=0; i< y; i++)tmp0[i] = new rgb[x];
#endif
	rgb ** tmp1; tmp1 = new rgb*[y];for(int i=0; i< y; i++)tmp1[i] = new rgb[x];
	rgb ** tmp2; tmp2 = new rgb*[y];for(int i=0; i< y; i++)tmp2[i] = new rgb[x];
	rgb ** tmp3; tmp3 = new rgb*[y];for(int i=0; i< y; i++)tmp3[i] = new rgb[x];
	rgb ** tmp4; tmp4 = new rgb*[y];for(int i=0; i< y; i++)tmp4[i] = new rgb[x];
#ifdef prefilter
	for(int i = 0; i < y; i++)
	{
		for(int j = 0; j < x; j++)
		{
			w = j; h = i;
			px = lj(-1);
			py = li(-1);
			nx = lj( 0);
			ny = li( 0);
			tmp0[i][j].r=image[i][j].r;
			tmp0[i][j].g=image[i][j].g;
			tmp0[i][j].b=image[i][j].b;
			if(image[py][px].r+image[py][px].g+image[py][px].b == //1
			   image[ny][px].r+image[ny][px].g+image[ny][px].b && //3 ++
			   image[py][px].r+image[py][px].g+image[py][px].b == //1 +-
			   image[py][nx].r+image[py][nx].g+image[py][nx].b || //2
			   
			   image[py][px].r+image[py][px].g+image[py][px].b == //1
			   image[ny][px].r+image[ny][px].g+image[ny][px].b && //3 +-
			   image[py][px].r+image[py][px].g+image[py][px].b == //1 ++
			   image[ny][nx].r+image[ny][nx].g+image[ny][nx].b || //4

			   image[py][nx].r+image[py][nx].g+image[py][nx].b == //2
			   image[ny][px].r+image[ny][px].g+image[ny][px].b && //3 -+
			   image[py][nx].r+image[py][nx].g+image[py][nx].b == //2 ++
			   image[ny][nx].r+image[ny][nx].g+image[ny][nx].b || //4

			   image[py][px].r+image[py][px].g+image[py][px].b == //1
			   image[py][nx].r+image[py][nx].g+image[py][nx].b && //2 ++
			   image[py][px].r+image[py][px].g+image[py][px].b == //1 -+
			   image[ny][nx].r+image[ny][nx].g+image[ny][nx].b    //4
			  )
			{
			   rgb tmp;

			   tmp.r=(image[py][px].r+image[ny][px].r+image[ny][nx].r+image[py][nx].r)/4;
			   tmp.g=(image[py][px].g+image[ny][px].g+image[ny][nx].g+image[py][nx].g)/4;
			   tmp.b=(image[py][px].b+image[ny][px].b+image[ny][nx].b+image[py][nx].b)/4;

			   tmp0[py][px].r=tmp.r;
			   tmp0[py][px].g=tmp.g;
			   tmp0[py][px].b=tmp.b;

			   tmp0[ny][px].r=tmp.r;
			   tmp0[ny][px].g=tmp.g;
			   tmp0[ny][px].b=tmp.b;

			   tmp0[py][nx].r=tmp.r;
			   tmp0[py][nx].g=tmp.g;
			   tmp0[py][nx].b=tmp.b;

			   tmp0[ny][nx].r=tmp.r;
			   tmp0[ny][nx].g=tmp.g;
			   tmp0[ny][nx].b=tmp.b;
			}
			if(image[py][px].r+image[py][px].g+image[py][px].b ==
			   image[ny][nx].r+image[ny][nx].g+image[ny][nx].b &&
			   image[ny][px].r+image[ny][px].g+image[ny][px].b ==
			   image[py][nx].r+image[py][nx].g+image[py][nx].b   )
			{
			   rgb tmp;

			   tmp.r=(image[py][px].r+image[ny][px].r)/2;
			   tmp.g=(image[py][px].g+image[ny][px].g)/2;
			   tmp.b=(image[py][px].b+image[ny][px].b)/2;

			   tmp0[py][px].r=tmp.r;
			   tmp0[py][px].g=tmp.g;
			   tmp0[py][px].b=tmp.b;

			   tmp0[ny][px].r=tmp.r;
			   tmp0[ny][px].g=tmp.g;
			   tmp0[ny][px].b=tmp.b;

			   tmp0[py][nx].r=tmp.r;
			   tmp0[py][nx].g=tmp.g;
			   tmp0[py][nx].b=tmp.b;

			   tmp0[ny][nx].r=tmp.r;
			   tmp0[ny][nx].g=tmp.g;
			   tmp0[ny][nx].b=tmp.b;
			}
		}
	}
	for(int i = 0; i < y; i++)
	{
		for(int j = 0; j < x; j++)
		{
			image[i][j].r = tmp0[i][j].r;
			image[i][j].g = tmp0[i][j].g;
			image[i][j].b = tmp0[i][j].b;
		}
	}
	for(int i=0; i< y; i++)delete[] tmp0[i];delete[] tmp0;
#endif
	for(int i = 0; i < y; i++)
	{
		for(int j = 0; j < x; j++)
		{
			tmp1[i][j].r = image[i][j].r;
			tmp1[i][j].g = image[i][j].g;
			tmp1[i][j].b = image[i][j].b;
			tmp1[i][j].a = image[i][j].a;
			tmp1[i][j].l = image[i][j].l;

			tmp2[i][j].r = image[i][j].r;
			tmp2[i][j].g = image[i][j].g;
			tmp2[i][j].b = image[i][j].b;
			tmp2[i][j].a = image[i][j].a;
			tmp2[i][j].l = image[i][j].l;

			tmp3[i][j].r = image[i][j].r;
			tmp3[i][j].g = image[i][j].g;
			tmp3[i][j].b = image[i][j].b;
			tmp3[i][j].a = image[i][j].a;
			tmp3[i][j].l = image[i][j].l;

			tmp4[i][j].r = image[i][j].r;
			tmp4[i][j].g = image[i][j].g;
			tmp4[i][j].b = image[i][j].b;
			tmp4[i][j].a = image[i][j].a;
			tmp4[i][j].l = image[i][j].l;
		}
	}
	for(int diff = 0; diff <= 0xF/2/*0xFF*/; diff++)
	{
		//cout << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b" << diff << " from " << (x>y?x:y);
		for(int i = 0; i < y; i++)
		{
			for(int j = 0; j < x; j++)
			{
				//if(image[i][j].a)
				{
					w = j; h = i;
					//horizontal
					px = lj(-1);
					py = li( 0);
					nx = lj(+1);
					ny = li( 0);
					//if(image[py][px].r == image[i][j].r && image[i][j].r != image[ny][nx].r ||
					//   image[py][px].g == image[i][j].g && image[i][j].g != image[ny][nx].g ||
					//   image[py][px].b == image[i][j].b && image[i][j].b != image[ny][nx].b ||
					//   
					//   image[py][px].r != image[i][j].r && image[i][j].r == image[ny][nx].r ||
					//   image[py][px].g != image[i][j].g && image[i][j].g == image[ny][nx].g ||
					//   image[py][px].b != image[i][j].b && image[i][j].b == image[ny][nx].b   )
					//{
					if(cd(image[py][px].r+image[py][px].g+image[py][px].b, image[i][j].r+image[i][j].g+image[i][j].b) <= shiftlong && cd(image[i][j].r+image[i][j].g+image[i][j].b, image[ny][nx].r+image[ny][nx].g+image[ny][nx].b) != shiftlong ||
					   cd(image[py][px].r+image[py][px].g+image[py][px].b, image[i][j].r+image[i][j].g+image[i][j].b) != shiftlong && cd(image[i][j].r+image[i][j].g+image[i][j].b, image[ny][nx].r+image[ny][nx].g+image[ny][nx].b) <= shiftlong   )
					{
						//tmp_rs = cd(image[py][px].r,image[ny][nx].r);
						//tmp_gs = cd(image[py][px].g,image[ny][nx].g); 
						//tmp_bs = cd(image[py][px].b,image[ny][nx].b);
						//if((tmp_rs+tmp_gs+tmp_bs)==diff-shiftshort)
						//{
							if(!(image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b))
							if(!(image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b))
							{
								tmp1[i][j].r = (image[py][px].r+image[ny][nx].r)/2;
								tmp1[i][j].g = (image[py][px].g+image[ny][nx].g)/2;
								tmp1[i][j].b = (image[py][px].b+image[ny][nx].b)/2;
								tmp1[i][j].a = false;
							}
						//}
					}
				}
				//if(false)
				//if(image[i][j].a)
				{
					w = j; h = i;
					//vertical
					px = lj( 0);
					py = li(-1);
					nx = lj( 0);
					ny = li(+1);
					if(cd(image[py][px].r+image[py][px].g+image[py][px].b, image[i][j].r+image[i][j].g+image[i][j].b) <= shiftlong && cd(image[i][j].r+image[i][j].g+image[i][j].b, image[ny][nx].r+image[ny][nx].g+image[ny][nx].b) != shiftlong ||
					   cd(image[py][px].r+image[py][px].g+image[py][px].b, image[i][j].r+image[i][j].g+image[i][j].b) != shiftlong && cd(image[i][j].r+image[i][j].g+image[i][j].b, image[ny][nx].r+image[ny][nx].g+image[ny][nx].b) <= shiftlong   )
					{
						//tmp_rs = cd(image[py][px].r,image[ny][nx].r);
						//tmp_gs = cd(image[py][px].g,image[ny][nx].g); 
						//tmp_bs = cd(image[py][px].b,image[ny][nx].b);
						//if((tmp_rs+tmp_gs+tmp_bs)==diff-shiftshort)
						//{
							if(!(image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b))
							if(!(image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b))
							{
								tmp2[i][j].r = (image[py][px].r+image[ny][nx].r)/2;
								tmp2[i][j].g = (image[py][px].g+image[ny][nx].g)/2;
								tmp2[i][j].b = (image[py][px].b+image[ny][nx].b)/2;
								tmp2[i][j].a = false;
							}
						//}
					}
				}
				//if(false)
				//if(image[i][j].a) 
				{
					w = j; h = i;
					//diagonal
					px = lj(-1);
					py = li(-1);
					nx = lj(+1);
					ny = li(+1);
					if(cd(image[py][px].r+image[py][px].g+image[py][px].b, image[i][j].r+image[i][j].g+image[i][j].b) <= shiftlong && cd(image[i][j].r+image[i][j].g+image[i][j].b, image[ny][nx].r+image[ny][nx].g+image[ny][nx].b) != shiftlong ||
					   cd(image[py][px].r+image[py][px].g+image[py][px].b, image[i][j].r+image[i][j].g+image[i][j].b) != shiftlong && cd(image[i][j].r+image[i][j].g+image[i][j].b, image[ny][nx].r+image[ny][nx].g+image[ny][nx].b) <= shiftlong   )
					{
						//tmp_rs = cd(image[py][px].r,image[ny][nx].r);
						//tmp_gs = cd(image[py][px].g,image[ny][nx].g); 
						//tmp_bs = cd(image[py][px].b,image[ny][nx].b);
						//if((tmp_rs+tmp_gs+tmp_bs)==diff-shiftshort)
						//{
							if(!(image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b))
							if(!(image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b))
							{
								tmp3[i][j].r = (image[py][px].r+image[ny][nx].r)/2;
								tmp3[i][j].g = (image[py][px].g+image[ny][nx].g)/2;
								tmp3[i][j].b = (image[py][px].b+image[ny][nx].b)/2;
								tmp3[i][j].a = false;
							}
						//}
					}
				}
				//if(false)
				//if(image[i][j].a)
				{
					w = j; h = i;
					//diagonal back
					px = lj(+1);
					py = li(-1);
					nx = lj(-1);
					ny = li(+1);
					if(cd(image[py][px].r+image[py][px].g+image[py][px].b, image[i][j].r+image[i][j].g+image[i][j].b) <= shiftlong && cd(image[i][j].r+image[i][j].g+image[i][j].b, image[ny][nx].r+image[ny][nx].g+image[ny][nx].b) != shiftlong ||
					   cd(image[py][px].r+image[py][px].g+image[py][px].b, image[i][j].r+image[i][j].g+image[i][j].b) != shiftlong && cd(image[i][j].r+image[i][j].g+image[i][j].b, image[ny][nx].r+image[ny][nx].g+image[ny][nx].b) <= shiftlong   )
					{
						//tmp_rs = cd(image[py][px].r,image[ny][nx].r);
						//tmp_gs = cd(image[py][px].g,image[ny][nx].g); 
						//tmp_bs = cd(image[py][px].b,image[ny][nx].b);
						//if((tmp_rs+tmp_gs+tmp_bs)==diff-shiftshort)
						//{
							if(!(image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b))
							if(!(image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b))
							{
								tmp4[i][j].r = (image[py][px].r+image[ny][nx].r)/2;
								tmp4[i][j].g = (image[py][px].g+image[ny][nx].g)/2;
								tmp4[i][j].b = (image[py][px].b+image[ny][nx].b)/2;
								tmp4[i][j].a = false;
							}
						//}
					}
				}
			}
		}
		for(int i = 0; i < y; i++)
		{
			for(int j = 0; j < x; j++)
			{
				//if(!tmp[i][j].a)
				{
					/*
					int sr = 0;
					bool changed = false;
					rgb stmp;
					
					stmp.r = image[i][j].r;
					stmp.g = image[i][j].g;
					stmp.b = image[i][j].b;

					image[i][j].r = 0;
					image[i][j].g = 0;
					image[i][j].b = 0;

					if(!tmp1[i][j].a)
					{
						sr++;
						tmp1[i][j].a = true;

						image[i][j].r += tmp1[i][j].r;
						image[i][j].g += tmp1[i][j].g;
						image[i][j].b += tmp1[i][j].b;

						changed = true;
					}
					if(!tmp2[i][j].a)
					{
						sr++;
						tmp2[i][j].a = true;

						image[i][j].r += tmp2[i][j].r;
						image[i][j].g += tmp2[i][j].g;
						image[i][j].b += tmp2[i][j].b;

						changed = true;
					}
					if(!tmp3[i][j].a)
					{
						sr++;
						tmp3[i][j].a = true;

						image[i][j].r += tmp3[i][j].r;
						image[i][j].g += tmp3[i][j].g;
						image[i][j].b += tmp3[i][j].b;

						changed = true;
					}
					if(!tmp4[i][j].a)
					{
						sr++;
						tmp4[i][j].a = true;

						image[i][j].r += tmp4[i][j].r;
						image[i][j].g += tmp4[i][j].g;
						image[i][j].b += tmp4[i][j].b;

						changed = true;
					}
					if(changed)
					{
						image[i][j].r = image[i][j].r/sr;
						image[i][j].g = image[i][j].g/sr;
						image[i][j].b = image[i][j].b/sr;
					}
					else
					{
						image[i][j].r = stmp.r;
						image[i][j].g = stmp.g;
						image[i][j].b = stmp.b;
					}
					*/
					image[i][j].r = (tmp1[i][j].r+tmp2[i][j].r+tmp3[i][j].r+tmp4[i][j].r)/4;
					image[i][j].g = (tmp1[i][j].g+tmp2[i][j].g+tmp3[i][j].g+tmp4[i][j].g)/4;
					image[i][j].b = (tmp1[i][j].b+tmp2[i][j].b+tmp3[i][j].b+tmp4[i][j].b)/4;

					//image[i][j].a = true;
					//image[i][j].l = tmp1[i][j].l;
				}
			}
		}
	}
	for(int i=0; i< y; i++)delete[] tmp1[i];delete[] tmp1;
	for(int i=0; i< y; i++)delete[] tmp2[i];delete[] tmp2;
	for(int i=0; i< y; i++)delete[] tmp3[i];delete[] tmp3;
	for(int i=0; i< y; i++)delete[] tmp4[i];delete[] tmp4;
}