#include "shared.h"
extern rgb alpha;
void Convert(char * memblock, int size, char * name, char *type)
{
	unsigned short w; 
	unsigned short h; 
	if(!strcmp(type,"BMP"))
	{
		(short)memblock[18]<0?w=(short)memblock[18]+256:w=memblock[18];memblock[19]<0?w+=(short)(memblock[19]+256)*256:w+=(short)(memblock[19])*256; 
		(short)memblock[22]<0?h=(short)memblock[22]+256:h=memblock[22];memblock[23]<0?h+=(short)(memblock[23]+256)*256:h+=(short)(memblock[23])*256;
		if((short)memblock[28]!=24)
		{
			cout << "Not a 24 bit BitMap file with name " << name << "\n";
			return;
		}
	}
	if(!strcmp(type,"TGA"))
	{
		if(*(unsigned short *)&memblock[16]!=24)
		{
			cout << "Not a 24 bit TGA file with name " << name << "\n";
			return;
		}
		w = *(unsigned short *)&memblock[12];
		h = *(unsigned short *)&memblock[14];
		//cout << w << " " << h;
	}
	//if(w%2)
	//{
	//	cout << "Can't work currently with non power of two images BitMap file with name " << name << "\n";
	//	return;
	//}
	short x = w*2; short y = h*2;
	rgb ** image; image = new rgb*[y];
	for(int i=0; i< y; i++)image[i] = new rgb[x];
	
	int a = size-1;
	for(int i = 0;i < y; i++)
	{
		for(int j = 0;j < x; j++)
		{
			if(!(i%2)&&(j%2))
			{
				(short)memblock[a]<0?image[i][j].r=(short)memblock[a]+256:image[i][j].r=(short)memblock[a];a--;
				(short)memblock[a]<0?image[i][j].g=(short)memblock[a]+256:image[i][j].g=(short)memblock[a];a--;
				(short)memblock[a]<0?image[i][j].b=(short)memblock[a]+256:image[i][j].b=(short)memblock[a];a--;
				image[i][j].a = false;
				image[i][j].l = 0;
			}
			else
			{
				image[i][j].r=alpha.r;
				image[i][j].g=alpha.g;
				image[i][j].b=alpha.b;
				image[i][j].a = true;
				image[i][j].l = 0;
			}
		}
	}
	Recalculate(image,x,y);
	int sizewrite;
	int header;
	if(!strcmp(type,"BMP")) header = 54;
	if(!strcmp(type,"TGA")) header = 18;
	sizewrite = header+x*y*3;
	char * memblockwrite;
	memblockwrite = new char[sizewrite];
	for(int i = 0; i < header; i++)
	{
		memblockwrite[i] = memblock[i];
	}
	if(!strcmp(type,"BMP"))
	{
		memblockwrite[18] = (char)x-((x/256)*256);
		memblockwrite[19] = (char)(x/256);
		memblockwrite[22] = (char)y-((y/256)*256);
		memblockwrite[23] = (char)(y/256);
	}
	if(!strcmp(type,"TGA"))
	{
		memcpy(&memblockwrite[12], &x,2);
		memcpy(&memblockwrite[14], &y,2);
	}
	int b = (sizewrite)-1;
	for(int i = 0;i < y; i++)
	{
		for(int j = 0;j < x; j++)
		{
			memblockwrite[b] = (char)image[i][j].r;b--;
			memblockwrite[b] = (char)image[i][j].g;b--;
			memblockwrite[b] = (char)image[i][j].b;b--;
		}
	}
	_mkdir("scaled");
	char namewrite[MAX_PATH];
	strcpy(namewrite,"scaled\\");
	strcat(namewrite,name);
	cout << namewrite << "\n";
	writefile(memblockwrite,sizewrite,namewrite);
	delete memblockwrite;
	for(int i=0; i< y; i++)delete[] image[i];delete[] image;
}