#include "shared.h"
#define MAXDIFF 0xFF*3
short w,xmax;
short h,ymax;
short lj(short num)
{
	if(w+num<    0) return (xmax+num);
	if(w+num>=xmax) return w+num-xmax;
	                return w+num     ;
}
short li(short num)
{
	if(h+num<    0) return (ymax+num);
	if(h+num>=ymax) return h+num-ymax;
	                return h+num     ;
}
short cd(short a, short b)
{
	if(a-b>=0) return a-b; else return b-a;
}
short tmp_rs, tmp_gs, tmp_bs;
short px,py,nx,ny;
extern rgb alpha;
void Recalculate(rgb **image,short x, short y)
{
	xmax = x; ymax = y;	
	for(int i = 0; i < y; i++)
	{
		for(int j = 0; j < x; j++)
		{
			if(image[i][j].a)
			{
				w = j; h = i;
				px = lj(-1);	py = li( 0);nx = lj(+1);ny = li( 0);
				if((image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b&&!image[py][px].a)&&
				   (image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b&&!image[ny][nx].a))
				   {image[i][j].a = false;}
				px = lj( 0);py = li(-1);	nx = lj( 0);ny = li(+1);
				if((image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b&&!image[py][px].a)&&
				   (image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b&&!image[ny][nx].a))
				   {image[i][j].a = false;}
				px = lj(-1);	py = li(-1);	nx = lj(+1);ny = li(+1);
				if((image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b&&!image[py][px].a)&&
				   (image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b&&!image[ny][nx].a))
				   {image[i][j].a = false;}
				px = lj(+1);py = li(-1);	nx = lj(-1);	ny = li(+1);
				if((image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b&&!image[py][px].a)&&
				   (image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b&&!image[ny][nx].a))
				   {image[i][j].a = false;}
			}
		}
	}
	for(int diff = 0; diff <= MAXDIFF; diff++)
	{
		cout << "\b\b\b\b\b\b\b\b" << (float)diff/(float)MAXDIFF*10+10 << "%";

		for(int i = 0; i < y; i++)
		{
			for(int j = 0; j < x; j++)
			{
				if(image[i][j].a)
				{
					w = j; h = i;
					//horizontal
					px = lj(-1);
					py = li( 0);
					nx = lj(+1);
					ny = li( 0);
					
					if((image[py][px].a)||(image[ny][nx].a)) continue;
					tmp_rs = cd(image[py][px].r,image[ny][nx].r);
					tmp_gs = cd(image[py][px].g,image[ny][nx].g); 
					tmp_bs = cd(image[py][px].b,image[ny][nx].b);
					if((tmp_rs+tmp_gs+tmp_bs)==diff)
					{
						if(image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b)continue;
						if(image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b)continue;

						image[i][j].r = (image[py][px].r+image[ny][nx].r)/2;
						image[i][j].g = (image[py][px].g+image[ny][nx].g)/2;
						image[i][j].b = (image[py][px].b+image[ny][nx].b)/2;
						image[i][j].a = false;
					}
				}
			}
		}
		for(int i = 0; i < y; i++)
		{
			for(int j = 0; j < x; j++)
			{
				if(image[i][j].a)
				{
					w = j; h = i;
					//vertical
					px = lj( 0);
					py = li(-1);
					nx = lj( 0);
					ny = li(+1);

					if((image[py][px].a)||(image[ny][nx].a)) continue;
					tmp_rs = cd(image[py][px].r,image[ny][nx].r);
					tmp_gs = cd(image[py][px].g,image[ny][nx].g); 
					tmp_bs = cd(image[py][px].b,image[ny][nx].b);
					if((tmp_rs+tmp_gs+tmp_bs)==diff)
					{
						if(image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b)continue;
						if(image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b)continue;

						image[i][j].r = (image[py][px].r+image[ny][nx].r)/2;
						image[i][j].g = (image[py][px].g+image[ny][nx].g)/2;
						image[i][j].b = (image[py][px].b+image[ny][nx].b)/2;
						image[i][j].a = false;
					}
				}
			}
		}
		for(int i = 0; i < y; i++)
		{
			for(int j = 0; j < x; j++)
			{
				if(image[i][j].a)
				{
					w = j; h = i;
					//diagonal
					px = lj(-1);
					py = li(-1);
					nx = lj(+1);
					ny = li(+1);

					if((image[py][px].a)||(image[ny][nx].a)) continue;
					tmp_rs = cd(image[py][px].r,image[ny][nx].r);
					tmp_gs = cd(image[py][px].g,image[ny][nx].g); 
					tmp_bs = cd(image[py][px].b,image[ny][nx].b);
					if((tmp_rs+tmp_gs+tmp_bs)==diff)
					{
						if(image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b)continue;
						if(image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b)continue;

						image[i][j].r = (image[py][px].r+image[ny][nx].r)/2;
						image[i][j].g = (image[py][px].g+image[ny][nx].g)/2;
						image[i][j].b = (image[py][px].b+image[ny][nx].b)/2;
						image[i][j].a = false;
					}
				}
			}
		}
		for(int i = 0; i < y; i++)
		{
			for(int j = 0; j < x; j++)
			{
				if(image[i][j].a)
				{
					w = j; h = i;
					//diagonal back
					px = lj(+1);
					py = li(-1);
					nx = lj(-1);
					ny = li(+1);

					if((image[py][px].a)||(image[ny][nx].a)) continue;
					tmp_rs = cd(image[py][px].r,image[ny][nx].r);
					tmp_gs = cd(image[py][px].g,image[ny][nx].g); 
					tmp_bs = cd(image[py][px].b,image[ny][nx].b);
					if((tmp_rs+tmp_gs+tmp_bs)==diff)
					{
						if(image[py][px].r==alpha.r&&image[py][px].g==alpha.g&&image[py][px].b==alpha.b)continue;
						if(image[ny][nx].r==alpha.r&&image[ny][nx].g==alpha.g&&image[ny][nx].b==alpha.b)continue;

						image[i][j].r = (image[py][px].r+image[ny][nx].r)/2;
						image[i][j].g = (image[py][px].g+image[ny][nx].g)/2;
						image[i][j].b = (image[py][px].b+image[ny][nx].b)/2;
						image[i][j].a = false;
					}
				}
			}
		}
	}
}